using System.Security.Cryptography.X509Certificates;
using FitConnect.Models;
using Microsoft.Extensions.Logging;

namespace FitConnect;

/// <summary>
/// The FitConnect API Client
/// </summary>
public class Client {
    private readonly string _clientId;
    private readonly string _clientSecret;
    private Sender _sender;
    private Subscriber _subscriber;


    public Client(FitConnectEndpoints endpoints,
        string clientId, string clientSecret,
        X509Certificate2? certificate = null,
        ILogger? logger = null) {
        _clientId = clientId;
        _clientSecret = clientSecret;
        _sender = new Sender(logger, endpoints, certificate);
        _subscriber = new Subscriber(logger, endpoints, certificate);
    }

    /// <summary>
    /// Sending a submission to the FitConnect API
    /// </summary>
    /// <param name="submission">The submission to send</param>
    /// <returns>success</returns>
    public async Task<bool> SendSubmissionAsync(Submission submission) {
        throw new NotImplementedException();
    }

    /// <summary>
    /// Gets all submissions from the FitConnect API
    /// </summary>
    /// <returns>List of the available submissions</returns>
    public async Task<List<Submission>> GetSubmissionsAsync() {
        throw new NotImplementedException();
    }

    /// <summary>
    /// Sending a submission to the FitConnect API
    /// </summary>
    /// <param name="submission">The submission to send</param>
    /// <returns>success</returns>
    public bool SendSubmission(Submission submission) => SendSubmissionAsync(submission).Result;

    /// <summary>
    /// Gets all submissions from the FitConnect API
    /// </summary>
    /// <returns>List of the available submissions</returns>
    public List<Submission> GetSubmissions() => GetSubmissionsAsync().Result;
}
