using System.Security.Cryptography.X509Certificates;
using FitConnect.BaseClasses;
using FitConnect.Models;
using Microsoft.Extensions.Logging;

namespace FitConnect;

/// <summary>
/// Client to the FitConnect Routing Api
/// </summary>
public class Routing : RestCallService {
    private readonly ILogger? _logger;
    private readonly FitConnectEndpoints _endpoints;
    private readonly X509Certificate2? _certificate;

    public Routing(ILogger? logger, FitConnectEndpoints endpoints,
        X509Certificate2? certificate = null) {
        _logger = logger;
        _endpoints = endpoints;
        _certificate = certificate;
    }


    /// <summary>
    /// 
    /// </summary>
    /// <param name="filter"></param>
    /// <param name="offset"></param>
    /// <param name="limit"></param>
    /// <returns></returns>
    public List<Area> GetAreas(string filter, int offset = 0, int limit = 100) =>
        GetAreasAsync(filter, offset, limit).Result;


    /// <summary>
    /// 
    /// </summary>
    /// <param name="filter"></param>
    /// <param name="offset"></param>
    /// <param name="limit"></param>
    /// <returns></returns>
    public async Task<List<Area>> GetAreasAsync(string filter, int offset = 0, int limit = 100) {
        return new List<Area>();
    }


    /// <summary>
    /// 
    /// </summary>
    /// <param name="leikaKey"></param>
    /// <param name="ags"></param>
    /// <param name="ars"></param>
    /// <param name="areaId"></param>
    /// <param name="offset"></param>
    /// <param name="limit"></param>
    /// <returns></returns>
    public async Task<List<Route>> GetRoutesAsync(string leikaKey, string ags, string ars,
        string areaId, int offset = 0, int limit = 100) {
        return new List<Route>();
    }


    /// <summary>
    /// 
    /// </summary>
    /// <param name="leikaKey"></param>
    /// <param name="ags"></param>
    /// <param name="ars"></param>
    /// <param name="areaId"></param>
    /// <param name="offset"></param>
    /// <param name="limit"></param>
    /// <returns></returns>
    public List<Route> GetRoutes(string leikaKey, string ags, string ars,
        string areaId, int offset = 0, int limit = 100) =>
        GetRoutesAsync(leikaKey, ags, ars, areaId, offset, limit).Result;
}
